package ru.dbotthepony.mc.otm

import net.minecraftforge.common.ForgeConfigSpec
import net.minecraftforge.fml.ModLoadingContext
import net.minecraftforge.fml.config.ModConfig

object ClientConfig {
	private val spec: ForgeConfigSpec
	private var registered = false

	private val _exosuitInventoryRows: ForgeConfigSpec.IntValue

	init {
		val specBuilder = ForgeConfigSpec.Builder()
		specBuilder.comment("Clientside Config").push("client")

		_exosuitInventoryRows = specBuilder
			.comment("Amount of inventory rows to show when wearing Exosuit")
			.defineInRange("exosuitInventoryRows", 3, 3, 6)

		specBuilder.pop()
		spec = specBuilder.build()
	}

	var exosuitInventoryRows: Int by _exosuitInventoryRows

	fun register() {
		check(!registered) { "Already registered config" }
		registered = true
		ModLoadingContext.get().registerConfig(ModConfig.Type.CLIENT, spec)
	}
}
