package ru.dbotthepony.mc.otm.android

import com.mojang.blaze3d.vertex.PoseStack
import net.minecraft.nbt.CompoundTag
import ru.dbotthepony.mc.otm.capability.MatteryPlayerCapability
import ru.dbotthepony.mc.otm.core.set

abstract class AndroidSwitchableFeature(type: AndroidFeatureType<*>, android: MatteryPlayerCapability) : AndroidFeature(type, android) {
	var isActive by synchronizer.bool(setter = setter@{ value, access, setByRemote ->
		if (value != access.read()) {
			access.write(value)

			if (!setByRemote) {
				if (value) {
					applyModifiers()
				} else {
					removeModifiers()
				}
			}
		}
	})

	open val allowToSwitchByPlayer: Boolean get() = true

	// TODO: PoseStack is stripped from server dist
	// but it doesn't seem to cause issues?
	abstract fun renderIcon(stack: PoseStack, x: Float, y: Float, width: Float, height: Float)

	override fun serializeNBT(): CompoundTag {
		return super.serializeNBT().also {
			it["isActive"] = isActive
		}
	}

	override fun deserializeNBT(nbt: CompoundTag) {
		super.deserializeNBT(nbt)
		isActive = nbt.getBoolean("isActive")
	}
}
